%define contentdir /var/www
%define mod_ssl_ver 2.8.22
%define piranha62 0
%define suexec_caller apache
%define apache_release NORLUG
%define temp_mod_ssl_ver 1.3.33
Summary: The most widely used Web server on the Internet.
Name: apache
Version: 1.3.33
Release: 2.norlug
Group: System Environment/Daemons
URL:   http://httpd.apache.org
Source: http://www.apache.org/dist/httpd/apache_%{version}.tar.gz
Source1: http://www.apache.org/dist/httpd/apache_%{version}.tar.gz.asc
# removed for NORLUG test page
#Source2: spacer48.png
#Source3: apache-index.html
#Source4: poweredby.png
Source5: httpd.init
Source6: apache.logrotate
Source7: SSL-Certificate-Creation
Source8: index_norlug.shtml
Source9: icons_norlug.tar.gz
#Source10: http://www.modssl.org/source/mod_ssl-%{mod_ssl_ver}-%{temp_mod_ssl_ver}.tar.gz
Source10: http://www.modssl.org/source/mod_ssl-%{mod_ssl_ver}-%{version}.tar.gz
Source11: httpd.conf-dist
Patch0: mod_ssl-%{mod_ssl_ver}/pkg.sslcfg/sslcfg.patch
Patch1: apache_1.3.23-config.patch
#Patch2: apache_%{version}-eapi-%{mod_ssl_ver}.patch
Patch3: apache-1.3.11-apxs.patch
Patch4: apache_1.3.14-mkstemp.patch
Patch5: apache_1.3.14-redhat.patch
Patch6: apache_1.3.20-apachectl-init.patch
Patch7: mod_ssl-%{mod_ssl_ver}/pkg.sslsup/sslsup.patch
Patch8: apache_1.3.23-dbmdb.patch
Patch9: apache_1.3.27-db.patch
Patch10: apache_1.3.26-autoindex_norlug.patch
Patch11: apache_1.3.29-mod_usertrack.patch
Patch12: apache_1.3.30-http_core.patch
Patch13: apache_1.3.30-http_protocol.patch
License: Apache Software License 2.0
BuildRoot: %{_tmppath}/apache-%{version}-root
BuildPrereq: db4-devel, expat-devel, findutils, mm-devel
BuildPrereq: openssl-devel, perl
Requires: /etc/mime.types, gawk, /usr/share/magic.mime, /usr/bin/find
Prereq: /sbin/chkconfig, /bin/mktemp, /bin/rm, /bin/mv, /bin/sed, mailcap, grep
Prereq: sh-utils, textutils, /usr/sbin/useradd
Provides: webserver
Conflicts: thttpd
Epoch: 1

%description
Apache is a powerful, full-featured, efficient, and freely-available
Web server. Apache is also the most popular Web server on the Internet.

This version is updated for RH 7.x and contains many hacks.  Including
Debian's mod_autoindex (HTML 4.0 cleanup hacks), and NORLUG custom
test page.

%package devel
Group: Development/Libraries
Summary: Development tools for the Apache Web server.
Obsoletes: secureweb-devel
Provides: eapi = %{mod_ssl_ver}

%description devel
The apache-devel package contains the APXS binary and other files that
you need to build Dynamic Shared Objects (DSOs) for Apache.
If you are installing the Apache Web server and you want to be able to
compile or develop additional modules for Apache, you need to install
this package.

%package manual
Group: Documentation
Summary: Documentation for the Apache Web server.

%description manual
The apache-manual package contains the complete manual and reference
guide for the Apache Web server. The information can also be found on
the Web at http://www.apache.org/docs/.

%prep
%setup -q -n apache_%{version} -a9 -a10

cp -p mod_ssl-%{mod_ssl_ver}-%{version}/pkg.eapi/*.c src/ap/
cp -p mod_ssl-%{mod_ssl_ver}-%{version}/pkg.eapi/*.h src/include/
cat mod_ssl-%{mod_ssl_ver}-%{version}/pkg.eapi/eapi.patch | patch -p0 -b --suffix .eapi-%{mod_ssl_ver}

# mod_ssl aint out yet - thus, contrib/ does NOT exis
#cp -p mod_ssl-%{mod_ssl_ver}-%{temp_mod_ssl_ver}/pkg.eapi/*.c src/ap/
#cp -p mod_ssl-%{mod_ssl_ver}-%{temp_mod_ssl_ver}/pkg.eapi/*.h src/include/
#cat mod_ssl-%{mod_ssl_ver}-%{temp_mod_ssl_ver}/pkg.eapi/eapi.patch | patch -p0 -b --suffix .eapi-%{mod_ssl_ver}

rm -fv conf/httpd.conf-dist
cp -v %{SOURCE11} conf/

mkdir contrib
mv icons_norlug/ contrib/

#%patch0 -p0 -b .sslcfg
%patch1 -p1 -b .config
#%patch2 -p1 -b .eapi-%{mod_ssl_ver}
#%patch3 -p1 -b .apxs
%patch4 -p1 -b .mkstemp
# don't append Red Hat signature.
#%patch5 -p1 -b .redhat
%patch6 -p1 -b .apachectl-init
#%patch7 -p0 -b .sslsup
%patch8 -p1 -b .dbmdb
%patch9 -p1 -b .db
# new NORLUG autoindex module
rm -f src/modules/standard/mod_autoindex.c
touch src/modules/standard/mod_autoindex.c
%patch10 -p1 -b .autoindex_norlug
#%patch11 -p1 -b .mod_usertack

# norlug hacks
%patch12 -p1
%patch13 -p1

# Substitute values to match the configuration.  The first two are
# for the default httpd.conf file, the rest is for the mod_ssl
# additions. Last one enables NORLUG testpage SSI and disables Indexes :-)
sed -e 's,@@ServerRoot@@,%{_sysconfdir}/httpd,g' \
    -e 's,@@ContentRoot@@,%{contentdir},g' \
    -e 's,IfDefine SSL,IfDefine HAVE_SSL,g' \
    -e 's,^DocumentRoot "/etc/httpd/htdocs",#DocumentRoot "/etc/httpd/htdocs",g' \
    -e 's,^<Directory "/etc/httpd/cgi-bin">,<Directory "%{contentdir}/cgi-bin">,g' \
    -e 's,^ServerName new.host.name,#ServerName new.host.name,g' \
    -e 's,^ServerAdmin you@your.address,#ServerAdmin you@your.address,g' \
    -e 's,^SSLCipherSuite,#SSLCipherSuite,g' \
    -e 's,^SSLLogLevel info,SSLLogLevel error,g' \
    -e 's,Options Indexes FollowSymLinks,Options Includes FollowSymLinks,g' \
    conf/httpd.conf-dist > conf/httpd.conf
# hide modules, but show apache version and OS
#echo "ServerTokens OS" >> conf/httpd.conf
echo "ServerTokens full" >> conf/httpd.conf
# branding :-)
#perl -pi -e 's|" PLATFORM "| [NORLUG Edition] %{distribution} GNU/Linux |;' \
#        src/main/http_main.c
perl -pi -e 's|" PLATFORM "| [NORLUG Edition] Red Hat GNU/Linux |;' \
        src/main/http_main.c

%build
CFLAGS="$RPM_OPT_FLAGS -fPIC -DEAPI_MM_CORE_PATH='\"%{_localstatedir}/run/httpd.mm\"'" ; export CFLAGS
LIBS="-lpthread" ; export LIBS
EAPI_MM=SYSTEM; export EAPI_MM

./configure \
 	--prefix=%{_sysconfdir}/httpd \
 	--exec-prefix=%{_prefix} \
 	--bindir=%{_bindir} \
 	--sbindir=%{_sbindir} \
 	--mandir=%{_mandir} \
	--sysconfdir=%{_sysconfdir}/httpd/conf \
	--includedir=%{_includedir}/apache \
	--libexecdir=%{_libdir}/apache \
	--datadir=%{contentdir} \
	--iconsdir=%{contentdir}/icons \
	--htdocsdir=%{contentdir}/html \
	--manualdir=%{contentdir}/html/manual \
	--cgidir=%{contentdir}/cgi-bin \
 	--localstatedir=%{_localstatedir} \
	--runtimedir=%{_localstatedir}/run \
	--logfiledir=%{_localstatedir}/log/httpd \
	--proxycachedir=%{_localstatedir}/cache/httpd \
	--enable-module=all \
	--enable-shared=max \
	--enable-rule=EAPI \
	--disable-rule=WANTHSREGEX \
	--enable-module=auth_dbm \
	--with-perl=%{__perl} \
	--enable-suexec \
	--suexec-docroot=%{contentdir} \
%if %{piranha62}
	--suexec-uidmin=51 --suexec-gidmin=51 \
%endif
	--suexec-caller=%{suexec_caller}
make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make install root=$RPM_BUILD_ROOT

# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 $RPM_SOURCE_DIR/httpd.init \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/httpd

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/apache.logrotate \
	$RPM_BUILD_ROOT/etc/logrotate.d/apache

ln -s ../../var/log/httpd $RPM_BUILD_ROOT/etc/httpd/logs
ln -s ../../%{_libdir}/apache $RPM_BUILD_ROOT/etc/httpd/modules

# norlug version test page
install -m644 $RPM_SOURCE_DIR/index_norlug.shtml \
        $RPM_BUILD_ROOT%{contentdir}/html/index.shtml
#install -m644 $RPM_SOURCE_DIR/poweredby.png \
#	$RPM_BUILD_ROOT%{contentdir}/html
#tar -zxvf icons_norlug.tar.gz
install -m644 contrib/icons_norlug/* \
	$RPM_BUILD_ROOT%{contentdir}/icons/
# install Apache's default access and srm config files
install -m644 conf/access.conf-dist \
	$RPM_BUILD_ROOT/etc/httpd/conf/access.conf

install -m644 conf/srm.conf-dist \
	$RPM_BUILD_ROOT/etc/httpd/conf/srm.conf

# replace Apache's default config file with our patched version
install -m644 conf/httpd.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/httpd.conf

# modify perl scripts to call %{__perl}
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl5" | \
	xargs perl -pi -e "s|/usr/local/bin/perl5|%{__perl}|g;"
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|%{__perl}|g;"

# remove execute bits from CGIs
chmod -x cgi-bin/*

# fix up apxs so that it doesn't think it's in the build root
sed "s^$RPM_BUILD_ROOT^^g" $RPM_BUILD_ROOT%{_sbindir}/apxs > apxs.tmp && \
cat apxs.tmp > $RPM_BUILD_ROOT%{_sbindir}/apxs

# fixup the documentation file naming
find $RPM_BUILD_ROOT%{contentdir} -name "*.html.html" | xargs rename .html.html .html

# create a conf.d directory next to the regular one
install -m755 -d $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
# symlink from the conf.d directory to the historic location
ln -s ../conf/httpd.conf $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d

# fixup the apachectl script to make it include stuff that's supposed
# to be passed to httpd, which is stripped out by the make install target
# when it corrects the server path
cp $RPM_BUILD_ROOT%{_sbindir}/apachectl $RPM_BUILD_ROOT%{_sbindir}/apachectl.opt
sed -e \
	's,^HTTPD=%{_sbindir}/httpd$,HTTPD="%{_sbindir}/httpd `moduleargs` $OPTIONS",g' <\
	$RPM_BUILD_ROOT%{_sbindir}/apachectl.opt >\
	$RPM_BUILD_ROOT%{_sbindir}/apachectl

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add httpd
# safely add .htm to mime types if it is not already there
[ -f %{_sysconfdir}/mime.types ] || exit 0
TEMPTYPES=`/bin/mktemp /tmp/mimetypes.XXXXXX`
[ -z "$TEMPTYPES" ] && {
  echo "could not make temporary file, htm not added to %{_sysconfdir}/mime.types" >&2
  exit 1
}
( grep -v "^text/html"  %{_sysconfdir}/mime.types
  types=$(grep "^text/html" %{_sysconfdir}/mime.types | cut -f2-)
  echo -en "text/html\t\t\t"
  for val in $types ; do
      if [ "$val" = "htm" ] ; then
          continue
      fi
      echo -n "$val "
  done
  echo "htm"
) > $TEMPTYPES
cat $TEMPTYPES > %{_sysconfdir}/mime.types && /bin/rm -f $TEMPTYPES

# fix PHP .so paths
if [ -f %{_sysconfdir}/php.ini ] ; then
    perl -pi -e 's|extension_dir = \".\/\"|extension_dir = \"\/usr\/lib\/php4\"|g;' \
    %{_sysconfdir}/php.ini
fi

%pre
# Add the "apache" user
/usr/sbin/useradd -c "Apache" -u 48 \
	-s /bin/false -r -d /var/www apache 2> /dev/null || :

%preun
if [ $1 = 0 ]; then
	/sbin/service httpd stop > /dev/null 2>&1
	/sbin/chkconfig --del httpd
fi
  
%files
%defattr(-,root,root)
%doc ABOUT_APACHE Announcement LICENSE README cgi-bin
%dir %{_sysconfdir}/httpd
%dir %{_sysconfdir}/httpd/conf
#%dir %{_sysconfdir}/httpd/conf.d
#%config(noreplace) %{_sysconfdir}/httpd/conf.d/httpd.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/access.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/srm.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/httpd.conf
%config %{_sysconfdir}/httpd/conf/magic

%{_sysconfdir}/httpd/logs
%{_sysconfdir}/httpd/modules
%config(noreplace) %{_sysconfdir}/logrotate.d/apache
%config %{_sysconfdir}/rc.d/init.d/httpd

%dir %{contentdir}
%dir %{contentdir}/cgi-bin
%dir %{contentdir}/html
%config(noreplace) %{contentdir}/html/index.shtml
# removed as per NORLUG test page
#%{contentdir}/html/poweredby.png
%{contentdir}/icons

%dir %{_libdir}/apache
%{_libdir}/apache/httpd.exp
%{_libdir}/apache/*.so

%{_mandir}/man1/*
%{_mandir}/man8/ab.8*
%{_mandir}/man8/apachectl.8*
%{_mandir}/man8/httpd.8*
%{_mandir}/man8/logresolve.8*
%{_mandir}/man8/rotatelogs.8*
%{_mandir}/man8/suexec.8*
%{_sbindir}/ab
%{_sbindir}/apachectl
%{_sbindir}/httpd
%{_sbindir}/logresolve
%{_sbindir}/rotatelogs
%attr(4510,root,%{suexec_caller}) %{_sbindir}/suexec
%{_bindir}/*

%attr(0755,apache,root) %dir %{_localstatedir}/cache/httpd
%dir %{_localstatedir}/log/httpd

%files manual
%defattr(-,root,root)
%dir %{contentdir}/html/manual
%{contentdir}/html/manual/LICENSE
%{contentdir}/html/manual/*.html*
%{contentdir}/html/manual/howto
%{contentdir}/html/manual/images
%{contentdir}/html/manual/misc
%{contentdir}/html/manual/programs
%{contentdir}/html/manual/vhosts
%dir %{contentdir}/html/manual/mod
%{contentdir}/html/manual/mod/*.html
#%attr(0700,root,root) %dir %{contentdir}/html/manual/search
#%{contentdir}/html/manual/search/*

%files devel
%defattr(-,root,root)
%{_includedir}/apache
%{_sbindir}/apxs
%{_mandir}/man8/apxs.8*

%changelog
* Sat Oct 30 2004 Chip Cuccio <chipster@norlug.org> 1.3.33-2
- built /new mod_ssl/eapi

* Fri Oct 29 2004 Chip Cuccio <chipster@norlug.org> 1.3.33-1
- updated;
    o CAN-2004-0940 (cve.mitre.org)
      <http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2004-0940
    o CAN-2004-0492
      <http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2004-0492>

* Tue Oct 26 2004 Chip Cuccio <chipster@norlug.org> 1.3.32-2
- updated license

* Fri Oct 22 2004 Chip Cuccio <chipster@norlug.org> 1.3.32-1
- updated

* Sat Jul 16 2004 Chip Cuccio <chipster@norlug.org> 1.3.31-4
- updated EAPI and mod_ssl

* Thu Jun 03 2004 Chip Cuccio <http://norlug.org/~chipster/rpms> 1.3.31-3
- updated mod_ssl and EAPI to address:
  <http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2004-0488>

* Wed May 12 2004 Chip Cuccio <http://norlug.org/~chipster/rpms> 1.3.31-2
- update to 1.3.31

* Tue Jan 13 2004 Chip Cuccio <chipster@norlug.org> 1.3.29-6
- applied mod_usertrack patch to address cookie bug #24483;
  <http://nagoya.apache.org/bugzilla/show_bug.cgi?id=24483>

* Fri Dec 19 2003 Chip Cuccio <chipster@norlug.org> 1.3.29-5
- prevent logrotate script from being replaced

* Wed Dec 2 2003 Chip Cuccio <chipster@norlug.org> 1.3.29-4
- new index page
- branding cleanups

* Sun Nov 2 2003 Chip Cuccio <chipster@norlug.org> 1.3.29-3
- built with mod_ssl-2.8.16-1.3.29
  (which was released after apache-1.3.29)

* Wed Oct 29 2003 Chip Cuccio <chipster@norlug.org> 1.3.29-2
- update to 1.3.29;
  addresses <http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2003-0542>

* Sun Sep 7 2003 Chip Cuccio <chipster@norlug.org> 1.3.28-3
- rebuilt - cleaned spec
- cleaned default index page
- default to glibc-2.2

* Wed Jul 22 2003 Chip Cuccio <chipster@norlug.org> 1.3.28-2
- update to 1.3.28
- bug fix: <http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2003-0460>

* Wed Jul 2 2003 Chip Cuccio <chipster@norlug.org> 1.3.27-23
- disabled "ServerTokens Full"
- added branding

* Sun Jun 29 2003 Chip Cuccio <chipster@norlug.org> 1.3.27-19.norlug
- added mod_autoindex.c patch for cleaner output
- removed ("Red Hat Linux") patch from ServerSignature.
- used custon NORLUG index.shtml test page with images

